# ݵü

#twr <- c('twitteR', 'base64enc', 'ROAuth')
#install.packages(twr, dependencies = T)

library(twitteR)
library(base64enc)

options(httr_oauth_cache = T)
setup_twitter_oauth(consumer_key = 'xxxxxxxxxxxxxxxxxxxxxxxx',
                    consumer_secret = 'xxxxxxxxxxxxxxxxxxxxxxxx',
                    access_token = 'xxxxxxxxxxxxxxxxxxxxxxxx',
                    access_secret = 'xxxxxxxxxxxxxxxxxxxxxxxx')

#getCurRateLimitInfo()


# ˻
search.term <- "ݵü"
search.term <- iconv(search.term, 'CP949', 'UTF8')
search.term

result <- searchTwitter(searchString = search.term, n = 100, lang = 'ko') 
#class(searchResult) # "list"
result.tw <- twListToDF(result)
View(result.tw)


#
filename = paste('twitter(', searchterm ,').txt', sep='')
write.csv(result.tw, filename, quote = F, row.names = F)

# Ȯ
colnames(result.tw)

cc <- result.tw$text
cc

cc <- unique(cc)
cc 

# pkg

library(KoNLP) 
library(wordcloud) 
library(RColorBrewer)
useSejongDic()

#  , list vector ȯ 
cc.noun <- sapply(cc, extractNoun, USE.NAMES = F)
cc.noun <- unlist(cc.noun)
cc.noun
length(cc.noun)

# ó 
cc.noun <- gsub('[A-Za-z0-9]', '', cc.noun) #   
cc.noun <- gsub('[~!@#$%^&*()_+|?/:;,]', '', cc.noun) # Ư  
cc.noun <- gsub('[-]', '', cc.noun) #  
cc.noun <- gsub('[|]', '', cc.noun) #1 ̻ ̿ и 

# 2 ̻ ܾ 
cc.noun <- Filter(function(x){ nchar(x) >= 2}, cc.noun)
head(cc.noun, 50)

# ߰ ó 
cc.noun <- gsub("\u009f\u0093\u008c","", cc.noun)
cc.noun <- gsub("\u009f\u0094\u008aڷγ","", cc.noun)

# 󵵼 
word.count <- table(cc.noun)
word.count
head(sort(word.count,decreasing=T),30)

# Ŭ
pal = brewer.pal(4,"PuBu")
display.brewer.all()
wordcloud(names(word.count),freq=word.count,
          scale=c(4,1),rot.per = 0.0, min.freq = 3,
          random.order = F,random.color = T,colors=pal)

